#!/usr/bin/python

__doc__ = """Boost Software License - Version 1.0 - August 17th, 2003

Permission is hereby granted, free of charge, to any person or organization
obtaining a copy of the software and accompanying documentation covered by
this license (the "Software") to use, reproduce, display, distribute,
execute, and transmit the Software, and to prepare derivative works of the
Software, and to permit third-parties to whom the Software is furnished to
do so, all subject to the following:

The copyright notices in the Software and this entire statement, including
the above license grant, this restriction and the following disclaimer,
must be included in all copies of the Software, in whole or in part, and
all derivative works of the Software, unless such copies or derivative
works are solely in the form of machine-executable object code generated by
a source language processor.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE."""

import os
import gamefield


class patterns:
    def __init__(self):
        self.pattern = []
	self.generatepatterns()

    def generatepatterns(self):
	topdownpattern = []
	rightleftpattern = []
        
	#The top L pattern
        topdownpattern.append(((-1, 0),(-2,-1), 1,( 0, 1)))
        topdownpattern.append(((-1, 0),(-2, 1), 1,( 0,-1)))
	topdownpattern.append(((-1,-1),(-1, 1),-1,(-1, 0))) #the top v pattern
        topdownpattern.append(((-2, 0),(-3, 0),-1,(-1, 0))) #the top split pattern

	#the right l pattern
        rightleftpattern.append((( 0, 1),(-1, 2), 1,( 1, 0)))
        rightleftpattern.append((( 0, 1),( 1, 2), 1,(-1, 0)))
        rightleftpattern.append(((-1, 1),( 1, 1),-1,( 0, 1))) #the right v pattern
        rightleftpattern.append((( 0, 2),( 0, 3),-1,( 0, 1))) #the right split pattern

	self.pattern.extend(topdownpattern)
	self.pattern.extend(rightleftpattern)

	for mirrorpattern in topdownpattern:
		self.pattern.append(self.mirrortoptobottom(mirrorpattern))
	for mirrorpattern in rightleftpattern:
		self.pattern.append(self.mirrorrighttoleft(mirrorpattern))
	
    
    def mirrortoptobottom(self,pattern):
        return ((-pattern[0][0],pattern[0][1]),(-pattern[1][0],pattern[1][1]),pattern[2],(-pattern[3][0],pattern[3][1]))
    
    def mirrorrighttoleft(self,pattern):
        return ((pattern[0][0],-pattern[0][1]),(pattern[1][0],-pattern[1][1]),pattern[2],(pattern[3][0],-pattern[3][1]))

    def __repr__(self):
        string = "%d patterns\n" % len(self.pattern)

        for outpattern in self.pattern:
            string += str(outpattern) + "\n"

        return string

if __name__ == "__main__":
    field = gamefield.playground(os.getcwd() + "/testfield.dat")
    test = patterns(field)
    print test
